/*******************************************************************************

Copyright (c) 2010, Perforce Software, Inc.  All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1.  Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

2.  Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL PERFORCE SOFTWARE, INC. BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*******************************************************************************/

/*******************************************************************************
 * Name		: stdafx.h
 *
 * Author	: dbb
 *
 * Description	:  header file that includes just the standard includes to 
 *  be pre-compiled.
 *
 ******************************************************************************/

#ifdef StrVarName
#warning "StrVarName already defined"
#endif

#ifdef _WIN32

#include "targetver.h"

typedef unsigned __int64 P4UINT64;

#elif __APPLE__

#define abstract
#define __stdcall
#define _stdcall
#define __try
#define __except(arg)
#define E_FAIL -1
#define EXCEPTION_EXECUTE_HANDLER 1
#define _snprintf snprintf
#define _wcslen wcslen
#define __declspec(arg)

#include <stdint.h>

typedef char TCHAR;
typedef wchar_t WCHAR;
typedef int64_t __int64;
typedef uint64_t P4UINT64;

#endif

//#include <tchar.h>
#include <wchar.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#ifdef _WIN32
#include <share.h>
#endif

/*
#include "P4ClientDotNet.h"
#include "P4ServerDotNet.h"
#include "utils.h"
#include <strtable.h>
#include <strarray.h>
#include <strops.h>
*/

#ifdef _WIN32

#define WIN32_LEAN_AND_MEAN             // Exclude rarely-used stuff from Windows headers
// Windows Header Files:
#include <windows.h>

#endif

#ifndef P4INT64
#define P4INT64 __int64
#endif

#ifndef _StrVarName
#define _StrVarName
#include <strops.h>
#endif

#include "utils.h"
#include "p4base.h"
#include "DoublyLinkedList.h"
#include "Lock.h"

#ifndef _CharSetApi
#define _CharSetApi
#include <I18NAPI.h>
#endif

#ifndef _ClientApi
#define _ClientApi
#include <clientapi.h>
#endif

//#ifndef StrPtrDict
//#include <strtable.h>
//#endif

//
//#ifndef StrDict
//#include <strdict.h>
//#endif
